package messagebus_test

import (
	"fmt"
	"runtime"
	"sync"

	"github.com/vardius/message-bus"
)

func Example() {
	bus := messagebus.New(runtime.NumCPU())

	var wg sync.WaitGroup
	wg.Add(2)

	bus.Subscribe("topic", func(v bool) {
		defer wg.Done()
		fmt.Println("s1", v)
	})

	bus.Subscribe("topic", func(v bool) {
		defer wg.Done()
		fmt.Println("s2", v)
	})

	bus.Publish("topic", true)
	wg.Wait()
	// Unordered output:
	// s1 true
	// s2 true
}
